commit 8561cfd5daa061b8fe1526ebe5c787e876c9d6e6
Author: Varun Nagaraju <varun.nagaraju@percona.com>
Date:   Fri Jul 19 16:47:59 2024 +0530

    PS-9301 Assertion failure: dict0dict.ic:1102:col_index < table->n_cols thread 1406284440
    
    https://perconadev.atlassian.net/browse/PS-9301
    
    Bug#34800754 mysql/mysql-server@c614f7c65b8
    
    Issue:
    An assert in storage/innobase/include/dict0dict.ic
    triggers, indicating an invalid column index, while the column
    index is in fact correct.
    
    Background:
    The column index provided to dict_table_get_index_on_first_col
    is an index among all columns, while the n_cols field of
    dict_table_t only countains the number of non-virtual columns.
    Thus, the assert could be triggered with correct arguments.
    
    Fix:
    Changing the assert to compare against the n_t_cols field, the
    total number of columns.
    
    Change-Id: I90cc8c07d428c9117ca7873e9f53752d50f800e6

diff --git a/storage/innobase/include/dict0dict.ic b/storage/innobase/include/dict0dict.ic
index 6c3d311d9e2..c57c45039d8 100644
--- a/storage/innobase/include/dict0dict.ic
+++ b/storage/innobase/include/dict0dict.ic
@@ -1813,7 +1813,7 @@ dict_table_get_index_on_first_col(
         ulint                   col_index)	/*!< in: position of column
 						in table */
 {
-	ut_ad(col_index < table->n_cols);
+	ut_ad(col_index < table->n_t_cols);
 
 	ulint	non_v_col_index = col_index;
 	dict_col_t* column = NULL;

